<?php
define('_JEXEC', 1);
    
if (file_exists(__DIR__ . '/defines.php')) {
	include_once __DIR__ . '/defines.php';
}

if (!defined('_JDEFINES')) {
	define('JPATH_BASE', __DIR__);
	require_once JPATH_BASE . '/includes/defines.php';
}

require_once JPATH_BASE . '/includes/framework.php';

$app = JFactory::getApplication('site');
$jinput = $app->input;

$task = $jinput->getCmd('task', '');

if($task) {
  $task($jinput);
  
  $app->close();
}  
?>

<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="author" content="Petr Houba">
    <title>Změna hesla Superadmina pro CMS Joomla 2.5.x a 3.x</title>
    
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <link href="https://code.jquery.com/ui/1.12.1/themes/smoothness/jquery-ui.css" rel="stylesheet">
    
    <script src="https://code.jquery.com/jquery-3.1.1.min.js" integrity="sha256-hVVnYaiADRTO2PzUGmuLJr8BLUSjGIZsDYGmIJLv2b8=" crossorigin="anonymous"></script>
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.min.js" integrity="sha256-VazP97ZCwtekAsvgPBSUwPFKdrwD3unUfSGVYrahUqU=" crossorigin="anonymous"></script>
    
    <style type="text/css">
      body {
        background-color: #eeeeee;
      }
      
      p {
        padding: 15px;
      }
      
      #passwordStrength {
      	height: 16px;
      	display: block;
      }
      
      .strength0 {
      	background: #cccccc;
        width: 100%;
      }
      
      .strength1 {
      	width: 16.67%;
      	background: #F00000;
      }
      
      .strength2 {
      	width: 33.33%;	
      	background: #F04000;
      }
      
      .strength3 {
      	width: 50%;
      	background: #F09000;
      }
      
      .strength4 {
      	background: #90C000;
      	width: 66.67%;
      }
      
      .strength5 {
      	background: #609000;
      	width: 83.33%;
      }
      
      .strength6 {
      	background: #007000;
      	width: 100%;
      }
    </style>
    <script>
      var url = '<?php echo JURI::base(); ?>'; 
      
      function passwordStrength(password) {
      	var desc = new Array();
      	desc[0] = "Zadejte heslo";
        desc[1] = "Velmi slabé";
      	desc[2] = "Slabé";
      	desc[3] = "Uspokojivé";
      	desc[4] = "Dobré";
      	desc[5] = "Silné";
      	desc[6] = "Velmi silné";
      
      	var score = 0;
        
        if (password.length > 4) {
        	score++;
          
          //if password bigger than 6 give 1 point
        	if (password.length > 6) score++;
        
        	//if password has both lower and uppercase characters give 1 point	
        	if ( ( password.match(/[a-z]/) ) && ( password.match(/[A-Z]/) ) ) score++;
        
        	//if password has at least one number give 1 point
        	if (password.match(/\d+/)) score++;
        
        	//if password has at least one special caracther give 1 point
        	if ( password.match(/.[!,@,#,$,%,^,&,*,?,_,~,-,(,)]/) )	score++;
        
        	//if password bigger than 12 give another 1 point
        	if (password.length > 12) score++;
        }
        else if (password.length > 0){
          score = 1; 
        }
        else {
          score = 0;
        }
     
      	jQuery('#passwordDescription').html(desc[score]);
      	jQuery('#passwordStrength > div').removeClass('strength0 strength1 strength2 strength3 strength4 strength5  strength6');
        jQuery('#passwordStrength > div').addClass('strength' + score);
      }
      
      function submitForm(task) {
        var message = jQuery('#message');
        
        if(task == 'changePassword') {
          if(jQuery('#user').val() < 1) {
            message.html('Musíte vybrat uživatele.');
            message.dialog({
              title: "Upozornění",
              buttons: {
                'Zavřít': function() {
                  jQuery(this).dialog('close');
                }
              }
            });
            
            return false;
          }
          
          if(jQuery('#password').val() == '') {
            message.html('Musíte napsat heslo.');
            message.dialog({
              title: "Upozornění",
              buttons: {
                'Zavřít': function() {
                  jQuery(this).dialog('close');
                }
              }
            });
            
            return false;
          }
        }
        jQuery('input#task').val(task);
        jQuery.post('heslo.php', jQuery('#form').serialize())
          .done(function(data) {
            if(data) {
              message.html('Změna hesla byla provedena.');
              message.dialog({
                title: 'Hotovo',
                buttons: {
                  'Zavřít': function() {
                    jQuery(this).dialog('close');
                  },
                  'Jít do administrace': function() {
                    window.open(url +'administrator');
                    jQuery(this).dialog('close');
                  }
                }
              });
              
              jQuery('#form').trigger('reset');
            }
            else {
              message.html('Změna hesla bohužel nebyla provedena.');
              message.dialog({
                title: "Chyba",
                buttons: {
                  'Zavřít': function() {
                    jQuery(this).dialog('close');
                  }
                }
              });
            }  
          });
      }
    </script>
  </head>
  <body>
    <div class="container">
      <div class="row">
        <h2 class="col-md-12">Změna hesla pro účty Super Users v CMS Joomla 2.5.x a 3.x</h2>
        <p class="col-md-12 alert alert-danger">Tento jednoduchý formulář slouží pro nastavení zapomenutého hesla u jakéhokoliv Super Users účtu v Joomla 2.5.
    Skript se musí nacházet v rootu webu a po nastavení hesla ho nezapomeňte smazat!!!</p><br />
        <?php
          $superUsers = JAccess::getUsersByGroup(8);
          
          $options = array();
          $options[] = JHTML::_('select.option', 0, '- Vyberte uživatele -');
          foreach($superUsers AS $userId) {
            $user = JFactory::getUser($userId);
            $options[] = JHTML::_('select.option', $userId, $user->name.' ('.$user->username.')');
          }
        ?>
      </div>
      <div class="row">
        <form id="form" class="form-horizontal col-md-12" action="#">
          <div class="form-group">
            <label for="user" class="col-sm-2 control-label">Uživatel</label>
            <div class="col-sm-3">
            <?php
              echo JHTML::_('select.genericlist', $options, 'user', 'class="form-control"');
            ?>
            </div>
          </div>
          <div class="form-group">
            <label for="password" class="col-sm-2 control-label">Nové heslo</label>
            <div class="col-sm-3">
              <input id="password" class="form-control" type="text" name="password" onkeyup="passwordStrength(this.value)" >
              <div id="passwordDescription">Zadejte heslo</div>
              <div id="passwordStrength123" class="strength0"></div>
              <div id="passwordStrength" class="progress">
                <div class="progress-bar progress-bar-success strength0" role="progressbar" aria-valuenow="20" aria-valuemin="0" aria-valuemax="100"></div>
              </div>
            </div>
          </div>
          <div class="form-group">
            <div class="col-sm-3 col-sm-offset-2 text-right">
            <button type="button" class="btn btn-primary" onclick="submitForm('changePassword');">Změnit heslo</button>
            </div>
          </div>
          <input id="task" type="hidden" name="task" value="">  
        </form>
      </div>
    </div>
    <div id="message"></div>
  </body>
</html>

<?php
  function changePassword($jinput) {
    $app = JFactory::getApplication('site');
    
    $password = $jinput->getString('password');
    $userId = $jinput->getInt('user');
    
    $crypt = new JCryptPasswordSimple;
    $newPassword = $crypt->create($password);
        
    $user = JFactory::getUser($userId);
    
    $user->set('password', $newPassword);

    echo($user->save(true));    
  }
?>
  